package com.vendor.loader.adapter;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.vendor.loader.Log.Log;
import com.vendor.loader.Messages;
import com.vendor.loader.adapter.ImgAdapter;
import com.vendor.loader.controler.Builder;
import com.vendor.loader.model.CmdMonitor;
import com.vendor.loader.struct.UpgradeFileInfo;
import com.vendor.loader.struct.UpgradeInfo;
import com.vendor.loader.util.FileHelper;
import com.vendor.loader.util.SOCTTsPackageBuilder;
import java.io.File;
import java.util.ArrayList;
import java.util.List;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;

public class SOCTOTAImg extends ImgAdapter {
  public boolean callCreateSOCTOTA(String outputFile, ArrayList<UpgradeFileInfo> updateFiles, UpgradeInfo upgradeInfo) {
    if (outputFile == null || (new File(outputFile)).isDirectory())
      return false; 
    if (updateFiles == null || updateFiles.isEmpty())
      return false; 
    if (upgradeInfo == null)
      return false; 
    if (!validateInput(updateFiles))
      return false; 
    List<UpgradeFileInfo> selUpdateFiles = new ArrayList<>();
    for (int i = 0; i < updateFiles.size(); i++) {
      UpgradeFileInfo fileInfo = updateFiles.get(i);
      if (fileInfo.isSel() && !fileInfo.getFileName().isEmpty())
        selUpdateFiles.add(fileInfo); 
    } 
    if (selUpdateFiles.size() > 0) {
      IStatus status;
      FileHelper.createTempPartFile();
      SOCTTsPackageBuilder builder = new SOCTTsPackageBuilder();
      CmdMonitor cmdMonitor = new CmdMonitor();
      String[] error = new String[1];
      try {
        status = builder.createPackage(selUpdateFiles, upgradeInfo, outputFile, (IProgressMonitor)cmdMonitor);
      } catch (Throwable e) {
        error[0] = e.getMessage();
        Log.showError(error[0]);
        return false;
      } finally {
        cmdMonitor.done();
      } 
      printEndMessage((Builder)builder, error, status, outputFile);
      FileHelper.deleteTempPartFile();
    } else {
      Log.showError(Messages.SELECTFILE);
      return false;
    } 
    return true;
  }
}
